import kotlin.math.*

fun main() {
    println("Метод касательных")
    print("Введите начало диапазона a: ")
    var a: Double = readLine()!!.toDouble()
    print("Введите конец диапазона b: ")
    val b: Double = readLine()!!.toDouble()
    print("Введите шаг h: ")
    val h: Double = readLine()!!.toDouble()
    print("Введите точноть знаков после запятой t: ")
    val t: Double = (readLine()!!.toDouble())
    //Массив для хранения значений y
    val arrOfInsulation: MutableList<Double> = mutableListOf()
    val arrRoots: MutableList<Double> = mutableListOf()
    var x = a + h
    //Цикл, находящий подозреваемые на отрезки изоляции
    while (x <= b){
        val fx1 = f(x)
        val fx0 = f(x - h)
        if (fx0 * fx1 < 0 ) {
            check(x, h, arrOfInsulation)
        }
        if (fx0 == 0.0){
            arrRoots.add((x * 10.0.pow(t)).roundToInt() / 10.0.pow(t))
        }
        x += h
    }
    var counter = 0
    while (counter < arrOfInsulation.size) {
        a = arrOfInsulation[counter]
        x = ((a - (f(a)/fP(a))) * 10.0.pow(t+1)).roundToInt() / 10.0.pow(t+1)
        do {
            a = x
            x = ((a - (f(a)/fP(a))) * 10.0.pow(t+1)).roundToInt() / 10.0.pow(t+1)
            if(x == a){
                arrRoots.add((x * 10.0.pow(t)).roundToInt() / 10.0.pow(t))
                break
            }
        } while (x != a)
        counter += 2
    }
    println("Корни уравнения: ")
    for (i in 0 until arrRoots.size){
        println("${i+1}. - ${arrRoots[i]}")
    }
}

fun check(x: Double, h: Double, arrOfInsulation: MutableList<Double>) {
    //Проверка на отрезок изоляции
    var xMaybeStart = x - h
    val xMaybeEnd = x
    //flag - который определяет, является ли подозреваемый отрезком изоляции
    var flag: Boolean = true
    xMaybeStart+=(h * 0.1)
    while (xMaybeStart <= xMaybeEnd){
        //Округляем передаваемый х в функции, чтобы избежать погрешности подсчёта ЯП
        val fpx1 = fP((xMaybeStart - (h * 0.1)) * 10.0.pow(6).roundToInt() / 10.0.pow(6))
        val fpx0 = fP((xMaybeStart - (h * 0.1)) * 10.0.pow(6).roundToInt() / 10.0.pow(6))
        if (fpx1 * fpx0 < 0){
            flag = false
            break
        }
        xMaybeStart += (h * 0.1)
    }
    if (flag){
        arrOfInsulation.add(x - h)
        arrOfInsulation.add(x)
    }
}

//Функция подсчёта значения функции
fun f(x: Double): Double{
    return exp(x) - 2.0 + x.pow(2.0)
}

//Функция подсчёта значения производной функции
fun fP(x: Double): Double{
    return exp(x) + 2 * x
}