@file:Suppress("NAME_SHADOWING")

fun main() {
    print("Введите количество строк матрицы: ")
    val n = readln().toInt()
    print("Введите количество столбцов матрицы: ")
    val m = readln().toInt()
    val matrixZnach = MutableList(n){ MutableList<Double>(m){ 0.0 } }
    println("Введите матрицу:")
    for (i in 0 until n){
        matrixZnach[i] = readln().split(" ").map { i -> i.toDouble() }.toMutableList()
    }
    //Переменная для подсчёта элементов ГД для условия, в котором не все элементы ГД == 0
    var countElMD = 0
    //Первый цикл - для поиска элемента главной диагонали матрицы
    //Перебор по строкам (n)
    for (i in 0 until n){
        if(matrixZnach[i][i] == 0.0){
            //Шестой цикл - поиск столбца, где элемент в той же строке, что и элГД не равен 0
            //Перебор по столбцам, начиная с идущего после элГД
            for (j in i+1 until m-1){
                if(matrixZnach[i][j] != 0.0){
                    //Седьмой цикл - замена местами столбцов
                    //Перебор по строкам
                    for (k in 0 until n){
                        val temp = matrixZnach[k][i]
                        matrixZnach[k][i] = matrixZnach[k][j]
                        matrixZnach[k][j] = temp
                    }
                }
            }
        }
        if(matrixZnach[i][i] != 1.0 && matrixZnach[i][i] != 0.0){
            //Второй цикл - для того, чтобы превратить эл главной диагонали в единицу
            //Перебор по столбцам (m)
            val mainEl = matrixZnach[i][i]
            for (j in 0 until m){
                matrixZnach[i][j] = (matrixZnach[i][j] / mainEl)
            }
        }
        //Третий цикл - для того, чтобы выбрать строку элемента, который надо будет занулить
        //Перебор по строкам (n)
        if(matrixZnach[i][i] == 1.0){
            countElMD++
            for (j in 0 until n){
                if (j == i){
                    continue
                }
                //Четвертый цикл - для того, чтобы занулить элементы столбца, в котором элемент главной диагонали
                //Перебор по столбцам (m)
                val replaceEl = matrixZnach[j][i]
                if(replaceEl != 0.0){
                    for (k in 0 until m){
                        matrixZnach[j][k] = matrixZnach[i][k] * (-replaceEl) + matrixZnach[j][k]
                    }
                }
            }
        }
    }
    var constCount = m - 1 - countElMD
    var countRootsInd = 0
    val listRoots = MutableList<String>(m - 1){"0"}
    var strCount = 0
    //Пятый цикл - для того, чтобы вывести корни, если матрица квадратная
    //Перебор по строкам (n)
    if(n == m - 1){
        for (i in 0 until m - 1){
            val number = matrixZnach[i][m - 1]
            //Округление числа, так как насчитывается погрешность программы
            val roundedNumber = String.format("%.2f", number)
            println("Корень ${i + 1}: ${roundedNumber}")
        }
    }
    if(n != m - 1){
        for (i in m - 1 downTo  1){
            //Тут мы константы назначаем
            if (i > countElMD){
                listRoots[countRootsInd] = "с${constCount}"
                println("x${i}: ${listRoots[countRootsInd]}")
                countRootsInd++
                constCount--
            }
            else{
                print("x${i}: ")
                print("${matrixZnach[strCount][m - 1]} - ")
                var countRootsC = m - 1 - countElMD - 1
                for (j in countElMD until  m - 1){
                    print("(${matrixZnach[strCount][j]}${listRoots[countRootsC]})")
                    if (j != m - 2){
                        print(" - ")
                    }
                    countRootsC--
                }
                println()
                strCount++
            }
        }
    }
}