import kotlin.math.abs
import kotlin.math.pow
import kotlin.math.sin

fun main(args: Array<String>) {
    println("Метод прямоугольников")
    print("Введите начало диапазона a: ")
    val a: Double = readLine()!!.toDouble()
    print("Введите конец диапазона b: ")
    val b: Double = readLine()!!.toDouble()
    print("Введите количество узлов n: ")
    val n: Double = readLine()!!.toDouble()
    val h = (b - a) / n
    //Массив для хранения значений y
    val arrY: MutableList<Double> = mutableListOf()
    //Массив для хранения значений производной y
    val arrYP: MutableList<Double> = mutableListOf()
    var x: Double = a
    //Заполняем массив с y, на 3 больше для нахождения производной от последнего y, т.к. для его
    //нахождения требуется 4 значения y, 3 из которых больше чем он сам
    while (x <= b + h * 3 ){
        arrY.add(f(x))
        x += h
    }
    //Заполняем массив с y'
    var i = 0
    while (i <= n){
        //Разделяем массив с значениями y-ов от текущего y до значения y на 3 больше и подставляем в функцию
        arrYP.add(Pf(h, arrY.slice(i..i + 3).toMutableList()))
        i++
    }
    println("В процессе вычислений получено:")
    println("max(f'(x)) = ${arrYP.max()}")
    println("по левой формуле = ${h * arrY.slice(0.. (n - 1).toInt()).sum()}")
    println("по правой формуле = ${h * arrY.slice(1.. (n).toInt()).sum()}")
    println("погрешность = ${((b - a).pow(2.0)/(2 * n)) * (arrYP.max())}")
    var c = 0
}

//Функция подсчёта значения функции
fun f(x: Double): Double{
    return sin(2 * x + 1)
}

//Функция подсчета производной функции
fun Pf(h: Double, arrY4: MutableList<Double>): Double{
    val y1 = arrY4.get(0)
    val y2 = arrY4.get(1)
    val y3 = arrY4.get(2)
    val y4 = arrY4.get(3)
    return abs((1.0/(6.0*h))*(-11*arrY4.get(0)+18*arrY4.get(1)-9*arrY4.get(2)+2*arrY4.get(3)))
}