import kotlin.math.pow
import kotlin.math.roundToInt

fun main() {
    //Лист со значениями x и y, [] - х(при = 0) или у(при = 1), [] - значение
    print("Введите значений x: ")
    val arrayZnach: MutableList<MutableList<Double>>
    = mutableListOf( readLine()!!.split(" ").map { i -> i.toDouble() }.toMutableList())
    print("Введите значения y: ")
    arrayZnach.add(readLine()!!.split(" ").map { i -> i.toDouble() }.toMutableList())
    val arrayRoots = MutableList(arrayZnach[0].size){0.0}
    for (i in 0 until arrayZnach[0].size){
        var arrBuffer = genericMatrixPow(arrayZnach[0])
        for (j in 0 until arrayZnach[0].size){
            arrBuffer[j][i] = arrayZnach[1][j]
        }
        arrayRoots[i] = determinant(arrBuffer) / determinant(genericMatrixPow(arrayZnach[0]))
    }
    println("В итоге получен многочлен:")
    print("${((arrayRoots[0]) * 100).roundToInt() / 100.0}x^${arrayZnach[0].size - 1}")
    for (i in arrayZnach[0].size-2 downTo 0 ){
        print("+${((arrayRoots[arrayZnach[0].size - 1 - i]) * 100).roundToInt() / 100.0}x^${i}")
    }
}

//Передаётся массив иксов, чтобы на выходе получить матрицу с данными иксами, возведёнными в степень
fun genericMatrixPow(array: MutableList<Double>): MutableList<MutableList<Double>>{
    val matrix: MutableList<MutableList<Double>> = MutableList(array.size ){MutableList(array.size) {0.0} }
    //Пробегаемся по индексам полученного массива (по каждому полученному иксу)
    //Также i - номер строки матрицы
    for (i in 0 until array.size){
        var pow = array.size - 1 //Максимальная степень
        var j = 0 //Номер столбца в новой матрице
        while (pow >= 0){
            matrix[i][j] = array[i].pow(pow)
            pow--
            j++
        }
    }
    return matrix
}



//Функция находит определитель матрицы
fun determinant(matrix: MutableList<MutableList<Double>>): Double {
    val n = matrix.size
    if (n != matrix[0].size) {
        print("Матрица должна быть квадратной")
    }

    if (n == 1) {
        return matrix[0][0]
    }

    var det = 0.0
    for (j in 0 until n) {
        val minor = MutableList(n - 1) { MutableList(n - 1) { 0.0 } }
        for (row in 1 until n) {
            var colCount = 0
            for (col in 0 until n) {
                if (col != j) {
                    minor[row - 1][colCount] = matrix[row][col]
                    colCount++
                }
            }
        }
        det += matrix[0][j] * determinant(minor) * (if (j % 2 == 0) 1 else -1)
    }

    return det
}